//---------------------------------------------------------------------------
#pragma hdrstop
#include "SqlLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
__fastcall TLogger::TLogger()
{
	LogStream = NULL;
	FFileName="";
	OutputMemo=NULL;
	FDisplayError=false;
}
__fastcall TLogger::~TLogger()
{
	Release();
}
void __fastcall TLogger::SetFileName(AnsiString value)
{
	if(FFileName!=value)
	{
		Release();
		FFileName=value;
		//Initialize();
	}
}
void __fastcall TLogger::WriteLog(WideString Text)
{
	if(FOnWriteLog!=NULL)
	{
		FOnWriteLog(Text);
	}
	if(OutputMemo!=NULL)
	{
		OutputMemo->Lines->Add(Text);
	}
	if(FFileName.Length())
	{
		Text+=(WideString)"\r\n";
		LogStream->Write(Text.c_bstr(),Text.Length()*2);
	}
}
void __fastcall TLogger::WriteLog(WideString Text, bool WriteTime)
{
	if(WriteTime)
	{
		Text=(WideString)("/*"+Now().DateTimeString()+"*/ ")+Text;
	}
	WriteLog(Text);
}
void __fastcall TLogger::Release()
{
	if(LogStream!=NULL)
	{
		WideString EndText="/*"+Now().DateTimeString()+"*/ /*SQL Logger stopped*/\r\n";
		EndText+="-----------------------------------------------------------------------------\r\n";
		LogStream->Write(EndText.c_bstr(),EndText.Length()*2);
		delete LogStream;
		LogStream=NULL;
	}
}
void __fastcall TLogger::Initialize()
{
	if(FFileName.Length())
	{
		try
		{
			if(FileExists(FFileName))
			{
				LogStream=new TFileStream(FFileName,fmOpenReadWrite|fmShareDenyWrite);
				LogStream->Position=LogStream->Size;
			}
			else
			{
				LogStream=new TFileStream(FFileName,fmCreate);
			}
			WideString StartText="/*"+Now().DateTimeString()+"*/ /*SQL Logger started*/\r\n";
			LogStream->Write(StartText.c_bstr(),StartText.Length()*2);
		}
		catch(Exception &e)
		{
			FFileName="";
			LogStream=NULL;
			if(OutputMemo!=NULL)
			{
				OutputMemo->Lines->Add("/*Error open log file: "+FFileName+ "\r\n"+e.Message+"*/");
			}
			if(FDisplayError)
			{
				MessageBox(NULL, ("Error open log file: "+FFileName+ "\r\n"+e.Message).c_str(),"Log error",MB_ICONERROR|MB_TASKMODAL);
			}
			if(FOnWriteLog!=NULL)
			{
				FOnWriteLog("/*Error open log file: "+FFileName+ "\r\n"+e.Message+"*/");
			}
		}
	}
}
