//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SqlAdminMonitor.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ADOManagerQuery"
#pragma link "VirtualTrees"
#pragma link "JvComponent"
#pragma link "JvExControls"
#pragma link "JvGradient"
#pragma link "JvExExtCtrls"
#pragma link "JvGradientHeaderPanel"
#pragma link "JvRollOut"
#pragma link "TntComCtrls"
#pragma link "te_controls"
#pragma link "TntStdCtrls"
#pragma link "TntDBGrids"
#pragma link "TntActnList"
#pragma link "JvComponent"
#pragma link "JvExControls"
#pragma link "JvExExtCtrls"
#pragma link "JvGradientHeaderPanel"
#pragma link "JvRollOut"
#pragma link "SynMemo"
#pragma link "SynEdit"
#pragma link "SynEditHighlighter"
#pragma link "SynHighlighterSQL"
#pragma link "SynEditMiscClasses"
#pragma link "SynEditSearch"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
#define OBJ_SERVER 0
#define OBJ_CONNECTIONS 1
#define OBJ_LOGINS 2
#define OBJ_DATABASES 3
#define OBJ_BACKUP_DEVICES 4
#define OBJ_SERVER_ROLES 5
#define OBJ_DATABASE 6
#define OBJ_LOGIN 7
#define OBJ_LOGIN_DATABASE 8
#define OBJ_SERVER_OS 9
#define OBJ_USER_TABLES 10
#define	OBJ_VIEW_TABLES 11
#define	OBJ_SYSTEM_TABLES 12
//---------------------------------------------------------------------------
TServerForm *ServerForm;
WideString PropertyHeaders[]=
{
	"Property", "Value"
};
WideString DatabasePropertyCaptions[]=
{
	"Name", "Size", "Owner", "Date created", "Level", "Status"
};
WideString ServerPropertyCaptions[]=
{
	"Server name", "Machine name", "Edition","Engine edition",
	"Product version","Product level", "License type", "Number of Licenses",
	"Process ID", "Collation", "Clustered", "Full text search installed",
	"Integrated security only", "Single user", "SyncWithBackup"
};
WideString ConnectionHeaders[]=
{
	"Process ID", "Execution context ID",
	"Status", "Login account", "Host name",
	"Blocking process ID","Database", "Command"
};
WideString LoginHeaders[]=
{
	"Account name","Default database", "Default language", "User", "Remote"
};
WideString DatabaseHeaders[]=
{
	"Database name", "Owner", "Dbo only", "Read only", "Single user", "Detached",
	"Suspect", "Offline", "Inload", "Emergency mode", "StandBy", "Shut down",
	"In recovery", "Not recovered"
};
WideString DeviceHeaders[]=
{
	"Name", "Size", "Status", "Control type", "Physical name"
};
WideString ServerRoleHeaders[]=
{
	"Name", "Description"
};
WideString TableHeaders[]=
{
	"Table name", "Owner", "Type"
};
//---------------------------------------------------------------------------
__fastcall TSqlResult::TSqlResult(TADODataSet *SourceDataSet)
{
	DataSet=SourceDataSet;
	DataSource=new TDataSource(DataSet->Owner);
	DataSource->DataSet=DataSet;
	DBGrid=new TTntDBGrid(DataSet->Owner);
	DBGrid->DataSource=DataSource;
}
__fastcall TSqlResult::~TSqlResult()
{
	if(DataSet!=NULL)
		delete DataSet;
	if(DataSource!=NULL)
		delete DataSource;
	if(DBGrid!=NULL)
		delete DBGrid;
	if(TabSheet!=NULL)
		delete TabSheet;
}
void __fastcall TSqlResults::Show()
{
	TSqlResult* Item;
	for(int i=0;i<DataResults->Count;i++)
	{
		Item=(TSqlResult*)(DataResults->Items[i]);
		Item->TabSheet=new TTntTabSheet(FParent);
		Item->TabSheet->PageControl=FParent;
		Item->TabSheet->Caption="Record set #"+IntToStr(i+1);
		Item->DBGrid->Parent=(TWinControl*)(Item->TabSheet);
		Item->DBGrid->Align=alClient;
	}
}
void __fastcall TSqlResults::PopulateData()
{
	Clear();
	TADODataSet *DataSet=new TADODataSet(FOwner);;
	try
	{
		DataSet->Recordset=FADOQuery->Recordset;
		DataResults->Add((void*) (new TSqlResult(DataSet)));
	}
	catch(Exception &e)
	{
		MessageBox(((TForm*)FOwner)->Handle,e.Message.c_str(),"Error",MB_ICONERROR|MB_TASKMODAL);
	}
	int RecordSetNumber=2;
	while(DataSet->Recordset!=NULL)
	{
			DataSet=new TADODataSet(FOwner);
			int Row;
			try
			{
				DataSet->Recordset=FADOQuery->NextRecordset(Row);
			}
			catch(Exception &e)
			{
				MessageBox(((TForm*)FOwner)->Handle,("SQL #"+IntToStr(RecordSetNumber)+": "+e.Message).c_str(),"Error",MB_ICONERROR|MB_TASKMODAL);
			}
			if(DataSet->Recordset!=NULL)
			{
				DataResults->Add((void*) (new TSqlResult(DataSet)));
			}
			else
			{
				delete DataSet;
				break;
			}
			RecordSetNumber++;
	}
	Show();
}
void __fastcall TSqlResults::Clear()
{
	TSqlResult* Item;
	for(int i=0;i<DataResults->Count;i++)
	{
		Item=(TSqlResult*)(DataResults->Items[i]);
		delete Item;
	}
	DataResults->Clear();
}
__fastcall TSqlResults::TSqlResults(TComponent* Owner, TTntPageControl* Parent,TADOQuery* QuerySource)
{
	FOwner=Owner;
	FParent=Parent;
	FADOQuery=QuerySource;
	DataResults=new TList();
}
__fastcall TSqlResults::~TSqlResults()
{
	TSqlResult* Item;
	for(int i=0;i<DataResults->Count;i++)
	{
		try
		{
			Item=(TSqlResult*)(DataResults->Items[i]);
			Item->DataSet=NULL;
			Item->DataSource=NULL;
			Item->DBGrid=NULL;
			Item->TabSheet=NULL;
			delete Item;
		}
		catch(Exception &e)
		{

		}
	}
	//Clear();
	delete DataResults;
}
//---------------------------------------------------------------------------
__fastcall TServerForm::TServerForm(TComponent* Owner)
	: TForm(Owner)
{
	ServerTree->NodeDataSize=sizeof(ServerNode);
	ServerTree->Images=MainForm->ServerImageList;
	InfoTree->NodeDataSize=sizeof(InfoNode);
	InfoTree->Images=MainForm->ServerImageList;
	XmlInfo=new TTntStringList;
	Lock=new TCriticalSection();
	SqlResults=new TSqlResults(this, DataPageControl, ManagerQuery);
	Login();
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::Login()
{
	if(ManagerQuery->LoginPrompt()==mrOk)
	{
		//ManagerQuery->DisplayError=false;
		Caption="Server - "+ManagerQuery->ServerName;
		ServerTreeIni();
		StatusBar->Invalidate();
		Tag=1;
	}
}
void __fastcall TServerForm::Disconnect()
{
	ManagerQuery->Disconnect();
	//ManagerQuery->DisplayError=true;
	Caption="Server - No connection";
	ServerTree->Clear();
	InfoTree->Clear();
	//InfoTree->Header->Columns->Clear();
	//InfoTree->Tag=OBJ_CONNECTIONS;
	ServerInfoXml->Active=false;
	ServerInfoXml->XML->Clear();
	StatusBar->Invalidate();
	Tag=0;
	SqlResults->Clear();
}
void __fastcall TServerForm::ServerTreeIni()
{
	TVirtualNode* Server=ServerTree->AddChild(NULL);
	ServerNode* Node=(ServerNode*)ServerTree->GetNodeData(Server);
	Node->Caption=ManagerQuery->ServerName;
	Node->NodeType=OBJ_SERVER;
	TVirtualNode* ServerOS=ServerTree->AddChild(Server);
	Node=(ServerNode*)ServerTree->GetNodeData(ServerOS);
	Node->Caption="Server OS";
	Node->NodeType=OBJ_SERVER_OS;
	TVirtualNode* Connections=ServerTree->AddChild(Server);
	Node=(ServerNode*)ServerTree->GetNodeData(Connections);
	Node->Caption="Connections";
	Node->NodeType=OBJ_CONNECTIONS;
	TVirtualNode* Logins=ServerTree->AddChild(Server);
	Node=(ServerNode*)ServerTree->GetNodeData(Logins);
	Node->Caption="Login accounts";
	Node->NodeType=OBJ_LOGINS;
	ServerTree->HasChildren[Logins]=true;
	TVirtualNode* Databases=ServerTree->AddChild(Server);
	Node=(ServerNode*)ServerTree->GetNodeData(Databases);
	Node->Caption="Databases";
	Node->NodeType=OBJ_DATABASES;
	ServerTree->HasChildren[Databases]=true;
	TVirtualNode* Devices=ServerTree->AddChild(Server);
	Node=(ServerNode*)ServerTree->GetNodeData(Devices);
	Node->Caption="Backup devices";
	Node->NodeType=OBJ_BACKUP_DEVICES;
	TVirtualNode* ServerRoles=ServerTree->AddChild(Server);
	Node=(ServerNode*)ServerTree->GetNodeData(ServerRoles);
	Node->Caption="Server roles";
	Node->NodeType=OBJ_SERVER_ROLES;
	ServerTree->Selected[Server]=true;
	ServerTree->Expanded[Server]=true;
}
void __fastcall TServerForm::ServerTreeGetText(TBaseVirtualTree *Sender,
	  PVirtualNode Node, TColumnIndex Column, TVSTTextType TextType,
	  WideString &CellText)
{
	ServerNode* TreeNode=(ServerNode*)ServerTree->GetNodeData(Node);
	CellText=TreeNode->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::ServerTreeGetImageIndex(TBaseVirtualTree *Sender,
	  PVirtualNode Node, TVTImageKind Kind, TColumnIndex Column, bool &Ghosted,
	  int &ImageIndex)
{
	ServerNode* TreeNode=(ServerNode*)ServerTree->GetNodeData(Node);
	if(Kind==ikNormal||Kind==ikSelected)
	{
		switch(TreeNode->NodeType)
		{
			case OBJ_SERVER :
				ImageIndex=0;
			break;
			case OBJ_CONNECTIONS :
				ImageIndex=9;
			break;
			case OBJ_LOGINS :
				ImageIndex=14;
			break;
			case OBJ_DATABASES :
				ImageIndex=1;
			break;
			case OBJ_BACKUP_DEVICES :
				ImageIndex=15;
			break;
			case OBJ_SERVER_ROLES :
				ImageIndex=14;
			break;
			case OBJ_DATABASE :
				ImageIndex=17;
			break;
			case OBJ_LOGIN :
				ImageIndex=10;
			break;
			case OBJ_LOGIN_DATABASE :
				ImageIndex=17;
			break;
			case OBJ_SERVER_OS:
				ImageIndex=18;
			break;
			default: ImageIndex=16;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::ServerTreeFreeNode(TBaseVirtualTree *Sender,
	  PVirtualNode Node)
{
	ServerNode* TreeNode=(ServerNode*)ServerTree->GetNodeData(Node);
	TreeNode->Caption="";
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action=caFree;
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::StatusBarDrawPanel(TStatusBar *StatusBar,
	  TStatusPanel *Panel, const TRect &Rect)
{
	switch(Panel->Index)
	{
		case 0:
			MainForm->ServerImageList->Draw(StatusBar->Canvas,Rect.left,Rect.top,2,true);
			TextOut(StatusBar->Canvas->Handle,Rect.left+18,Rect.top,ManagerQuery->ConnectionID.c_str(),ManagerQuery->ConnectionID.Length());
		break;
		case 1:
			MainForm->ServerImageList->Draw(StatusBar->Canvas,Rect.left,Rect.top,13,true);
			TextOutW(StatusBar->Canvas->Handle,Rect.left+18,Rect.top,ManagerQuery->LoginName.c_bstr(),ManagerQuery->LoginName.Length());
		break;
		case 2:
			MainForm->ServerImageList->Draw(StatusBar->Canvas,Rect.left,Rect.top,17,true);
			TextOutW(StatusBar->Canvas->Handle,Rect.left+18,Rect.top,ManagerQuery->DatabaseName.c_bstr(),ManagerQuery->DatabaseName.Length());
		break;
		case 3:
			MainForm->ServerImageList->Draw(StatusBar->Canvas,Rect.left,Rect.top,10,true);
			TextOutW(StatusBar->Canvas->Handle,Rect.left+18,Rect.top,ManagerQuery->DBUser.c_bstr(), ManagerQuery->DBUser.Length());
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::UpdateInfo()
{
	//ManagerQuery->DisableControls();
	if(!ManagerQuery->UpdateProcessInfo())
	{
		//MessageBox(NULL,"Connection lost","Connection error",MB_ICONERROR|MB_TASKMODAL);
		//Disconnect();
		return;
	}
	TVirtualNode* ServerNodeItem;
	ServerNode* NodeData;
	XmlInfo->Clear();
	XmlInfo->Add("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
	XmlInfo->Add("<Server>");
	switch (InfoTree->Tag)
	{
		case OBJ_SERVER:
			StatusBar->Panels->Items[4]->Text="Checking server's version";
			StatusBar->Repaint();
			if(!ManagerQuery->ServerInfo(XmlInfo))
			{
				//Add error handle here
			}
		break;
		case OBJ_CONNECTIONS:
			StatusBar->Panels->Items[4]->Text="Checking server's connections";
			StatusBar->Repaint();
			if(!ManagerQuery->GetConnections(XmlInfo))
			{
				//Add error handle here
			}
		break;
		case OBJ_LOGINS:
			StatusBar->Panels->Items[4]->Text="Checking server's logins";
			StatusBar->Repaint();
			if(!ManagerQuery->GetLogins(XmlInfo))
			{
				//Add error handle here
			}
		break;
		case OBJ_DATABASES:
			StatusBar->Panels->Items[4]->Text="Checking server's databases";
			StatusBar->Repaint();
			if(!ManagerQuery->HasAccessDatabases(XmlInfo))
			{
				//Add error handle here
			}
		break;
		case OBJ_BACKUP_DEVICES:
			StatusBar->Panels->Items[4]->Text="Checking server's backup devices";
			StatusBar->Repaint();
			if(!ManagerQuery->GetBackupDevices(XmlInfo))
			{
				//Add error handle here
			}
		break;
		case OBJ_SERVER_ROLES:
			StatusBar->Panels->Items[4]->Text="Checking server roles";
			StatusBar->Repaint();
			if(!ManagerQuery->GetServerRoles(XmlInfo))
			{
				//Add error handle here
			}
		break;
		case OBJ_DATABASE:
			StatusBar->Panels->Items[4]->Text="Reading database's properties";
			StatusBar->Repaint();
			ServerNodeItem=ServerTree->GetFirstSelected();
			NodeData=(ServerNode*)ServerTree->GetNodeData(ServerNodeItem);
			if(!ManagerQuery->GetDBProperties(XmlInfo,NodeData->Caption,false))
			{
				//Add error handle here
			}
		break;
		case OBJ_LOGIN:
			StatusBar->Panels->Items[4]->Text="Reading login's properties";
			StatusBar->Repaint();
			ServerNodeItem=ServerTree->GetFirstSelected();
			NodeData=(ServerNode*)ServerTree->GetNodeData(ServerNodeItem);
			if(!ManagerQuery->GetLoginProperties(XmlInfo,NodeData->Caption,false))
			{
				//Add error handle here
			}
		break;
		case OBJ_LOGIN_DATABASE:
			StatusBar->Panels->Items[4]->Text="Reading login's database properties";
			StatusBar->Repaint();
			ServerNodeItem=ServerTree->GetFirstSelected()->Parent;
			NodeData=(ServerNode*)ServerTree->GetNodeData(ServerNodeItem);
			if(!ManagerQuery->GetLoginProperties(XmlInfo,NodeData->Caption,true))
			{
				////Add error handle here
			}
		break;
		case OBJ_SERVER_OS:
			StatusBar->Panels->Items[4]->Text="Reading Server OS properties";
			StatusBar->Repaint();
			if(!ManagerQuery->GetServerOS(XmlInfo))
			{
				////Add error handle here
			}
		break;
		case OBJ_USER_TABLES:
			StatusBar->Panels->Items[4]->Text="Reading database tables";
			StatusBar->Repaint();
			ServerNodeItem=ServerTree->GetFirstSelected()->Parent;
			NodeData=(ServerNode*)ServerTree->GetNodeData(ServerNodeItem);
			ManagerQuery->DatabaseName=NodeData->Caption;
			if(!ManagerQuery->GetUserTables(XmlInfo))
			{
				////Add error handle here
			}
			//ManagerQuery->WriteLog(XmlInfo->Text,false);
		break;
		case OBJ_VIEW_TABLES:
			StatusBar->Panels->Items[4]->Text="Reading database views";
			StatusBar->Repaint();
			ServerNodeItem=ServerTree->GetFirstSelected()->Parent;
			NodeData=(ServerNode*)ServerTree->GetNodeData(ServerNodeItem);
			ManagerQuery->DatabaseName=NodeData->Caption;
			if(!ManagerQuery->GetViewTables(XmlInfo))
			{
				////Add error handle here
			}
		break;
		case OBJ_SYSTEM_TABLES:
			StatusBar->Panels->Items[4]->Text="Reading database system tables";
			StatusBar->Repaint();
			ServerNodeItem=ServerTree->GetFirstSelected()->Parent;
			NodeData=(ServerNode*)ServerTree->GetNodeData(ServerNodeItem);
			ManagerQuery->DatabaseName=NodeData->Caption;
			if(!ManagerQuery->GetSystemTables(XmlInfo))
			{
				////Add error handle here
			}
		break;
	}
	XmlInfo->Add("</Server>");
	ServerInfoXml->LoadFromXML(XmlInfo->Text);
	XmlInfo->Clear();
	StatusBar->Panels->Items[4]->Text="";
	//StatusBar->Repaint();
}
void __fastcall TServerForm::DisplayInfo()
{
	_di_IXMLNode Item;
	switch (InfoTree->Tag)
	{
		case OBJ_SERVER:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Version");
		break;
		case OBJ_CONNECTIONS:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Connections");
		break;
		case OBJ_LOGINS:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Logins");
		break;
		case OBJ_DATABASES:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Databases");
		break;
		case OBJ_BACKUP_DEVICES:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("BackupDevices");
		break;
		case OBJ_SERVER_ROLES:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("ServerRoles");
		break;
		case OBJ_DATABASE:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("DBProperties");
		break;
		case OBJ_LOGIN :
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Login");
		break;
		case OBJ_SERVER_OS:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("OSInfo");
		break;
		case OBJ_USER_TABLES:
		case OBJ_VIEW_TABLES:
		case OBJ_SYSTEM_TABLES:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Tables");
		break;
		case OBJ_LOGIN_DATABASE:
			TVirtualNode* ServerNodeItem=ServerTree->GetFirstSelected();
			ServerNode* NodeData=(ServerNode*)ServerTree->GetNodeData(ServerNodeItem);
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Login")->GetChildNodes()->GetNode("Databases")->GetChildNodes()->GetNode(NodeData->Caption);
		break;
	}
	InfoTree->ChildCount[NULL]=Item->GetChildNodes()->Count;
	InfoTree->ReinitChildren(NULL,true);
	InfoTree->InvalidateChildren(NULL,true);
	StatusBar->Invalidate();
	//Lock->Release();
}
void __fastcall TServerForm::FormDestroy(TObject *Sender)
{
	delete XmlInfo;
	delete Lock;
	delete SqlResults;
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::CollapseButtonClick(TObject *Sender)
{
	RollOut->Collapse();
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::InfoTreeFreeNode(TBaseVirtualTree *Sender,
	  PVirtualNode Node)
{
	InfoNode* NodeData=(InfoNode*)InfoTree->GetNodeData(Node);
	delete NodeData->Captions;
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::InfoTreeInitNode(TBaseVirtualTree *Sender,
	  PVirtualNode ParentNode, PVirtualNode Node,
	  TVirtualNodeInitStates &InitialStates)
{
	InfoTree->MultiLine[Node]=false;
	InfoNode* NodeData=(InfoNode*)InfoTree->GetNodeData(Node);
	NodeData->Captions=new TTntStringList;
	_di_IXMLNode Parent;
	_di_IXMLNode Item;
	_di_IXMLNodeList SubItems;
	switch(InfoTree->Tag)
	{
		case OBJ_SERVER:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Version")->GetChildNodes()->Get(Node->Index);
			NodeData->Captions->Add(ServerPropertyCaptions[Node->Index]);
			NodeData->Captions->Add(Item->Text);
			return;
		break;
		case OBJ_CONNECTIONS:
			Parent=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Connections");
		break;
		case OBJ_LOGINS:
			Parent=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Logins");
		break;
		case OBJ_DATABASES:
			Parent=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Databases");
		break;
		case OBJ_BACKUP_DEVICES:
			Parent=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("BackupDevices");
		break;
		case OBJ_SERVER_ROLES:
			Parent=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("ServerRoles");
		break;
		case OBJ_DATABASE:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("DBProperties")->GetChildNodes()->Get(Node->Index);
			NodeData->Captions->Add(DatabasePropertyCaptions[Node->Index]);
			NodeData->Captions->Add(Item->Text);
			if(NodeData->Captions->Strings[0]==(WideString)"Status")
			{
				InfoTree->MultiLine[Node]=true;
			}
			return;
		break;
		case OBJ_LOGIN:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Login")->GetChildNodes()->Get(Node->Index);
			NodeData->Captions->Add(LoginHeaders[Node->Index]);
			NodeData->Captions->Add(Item->Text);
			return;
		break;
		case OBJ_SERVER_OS:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("OSInfo")->GetChildNodes()->Get(Node->Index);
			NodeData->Captions->Add(Item->NodeName);//LoginHeaders[Node->Index]);
			NodeData->Captions->Add(Item->Text);
			return;
		break;
		case OBJ_USER_TABLES:
		case OBJ_VIEW_TABLES:
		case OBJ_SYSTEM_TABLES:
			Parent=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Tables");
		break;
		case OBJ_LOGIN_DATABASE:
			TVirtualNode* ServerNodeItem=ServerTree->GetFirstSelected();
			ServerNode* ServerNodeData=(ServerNode*)ServerTree->GetNodeData(ServerNodeItem);
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Login")->GetChildNodes()->GetNode("Databases")->GetChildNodes()->GetNode(ServerNodeData->Caption)->GetChildNodes()->Get(Node->Index);
			if(Item->NodeName==(WideString)"DBRole")
			{
				NodeData->Captions->Add("Database role");
			}
			else
			{
				NodeData->Captions->Add("User");
			}
			NodeData->Captions->Add(Item->Text);
			return;
		break;
	}
	Item=Parent->GetChildNodes()->Get(Node->Index);
	SubItems=Item->GetChildNodes();
	int count=SubItems->Count;
	for(int i=0;i<count;i++)
	{
		NodeData->Captions->Add(SubItems->Get(i)->Text);
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::InfoTreeGetText(TBaseVirtualTree *Sender,
	  PVirtualNode Node, TColumnIndex Column, TVSTTextType TextType,
	  WideString &CellText)
{
	InfoNode* NodeData=(InfoNode*)InfoTree->GetNodeData(Node);
	if(Column<=NodeData->Captions->Count-1)
		CellText=NodeData->Captions->Strings[Column];
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::ServerTreeChange(TBaseVirtualTree *Sender,
	  PVirtualNode Node)
{
	if(Node!=NULL)
	{
		Lock->Enter();
		ServerNode* NodeData=(ServerNode*)ServerTree->GetNodeData(Node);
		InfoTree->Tag=NodeData->NodeType;
		InfoTreeIni();
		UpdateInfo();
		DisplayInfo();
		Lock->Leave();
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::InfoTreeIni()
{
	switch(InfoTree->Tag)
	{
		case OBJ_CONNECTIONS:
			//8 columns, Connections
			InfoTreeCheckColumn(8);
			for(int i=0;i<8;i++)
			{
				InfoTree->Header->Columns->Items[i]->Text=ConnectionHeaders[i];
			}
		break;
		case OBJ_LOGINS:
			InfoTreeCheckColumn(5);
			for(int i=0;i<5;i++)
			{
				InfoTree->Header->Columns->Items[i]->Text=LoginHeaders[i];
			}
		break;
		case OBJ_DATABASES:
			//5 Columns, Databases
			InfoTreeCheckColumn(14);
			for(int i=0;i<14;i++)
			{
				InfoTree->Header->Columns->Items[i]->Text=DatabaseHeaders[i];
			}
		break;
		case OBJ_BACKUP_DEVICES:
			//5 Columns, Devices
			InfoTreeCheckColumn(5);
			for(int i=0;i<5;i++)
			{
				InfoTree->Header->Columns->Items[i]->Text=DeviceHeaders[i];
			}
		break;
		case OBJ_SERVER_ROLES:
			InfoTreeCheckColumn(2);
			for(int i=0;i<2;i++)
			{
				InfoTree->Header->Columns->Items[i]->Text=ServerRoleHeaders[i];
			}
		break;
		case OBJ_SERVER:
		case OBJ_SERVER_OS:
		case OBJ_DATABASE:
		case OBJ_LOGIN:
		case OBJ_LOGIN_DATABASE:
			InfoTreeCheckColumn(2);
			for(int i=0;i<2;i++)
			{
				InfoTree->Header->Columns->Items[i]->Text=PropertyHeaders[i];
			}
		break;
		case OBJ_USER_TABLES:
		case OBJ_VIEW_TABLES:
		case OBJ_SYSTEM_TABLES:
			InfoTreeCheckColumn(3);
			for(int i=0;i<3;i++)
			{
				InfoTree->Header->Columns->Items[i]->Text=TableHeaders[i];
			}
		break;
	}
}
void __fastcall TServerForm::InfoTreeCheckColumn(int count)
{
	while(InfoTree->Header->Columns->Count<count)
	{
		InfoTree->Header->Columns->Add();
	}
	while(InfoTree->Header->Columns->Count>count)
	{
		InfoTree->Header->Columns->Delete(count);
	}
}
void __fastcall TServerForm::RollOutCollapse(TObject *Sender)
{
	RollOut->Caption="Object navigator";
	PanelSplitter->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::RollOutExpand(TObject *Sender)
{
	RollOut->Caption="";
	PanelSplitter->Enabled=true;
}
//---------------------------------------------------------------------------
__fastcall TUpdateThread::TUpdateThread(bool CreateSuspended, TForm* Owner)
	: TThread(CreateSuspended)
{
	FreeOnTerminate=true;
	//Priority=tpLowest;
	FOwner=Owner;
}
//---------------------------------------------------------------------------
void __fastcall TUpdateThread::Execute()
{
	while(!Terminated)
	{
		((TServerForm*)FOwner)->UpdateInfo();
		((TServerForm*)FOwner)->DisplayInfo();
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::ServerTreeInitNode(TBaseVirtualTree *Sender,
	  PVirtualNode ParentNode, PVirtualNode Node,
	  TVirtualNodeInitStates &InitialStates)
{
	if(ParentNode!=NULL)
	{
		ServerNode* NodeData=(ServerNode*)ServerTree->GetNodeData(ParentNode);
		ServerNode* ItemData=(ServerNode*)ServerTree->GetNodeData(Node);
		_di_IXMLNode Item;
		switch (NodeData->NodeType)
		{
			case OBJ_LOGINS:
				ItemData->NodeType=OBJ_LOGIN;
				Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Logins")->GetChildNodes()->Get(Node->Index)->GetChildNodes()->GetNode("Name");
				ItemData->Caption=Item->Text;
				//ServerTree->HasChildren[Node]=true;
				//ServerTree->InvalidateNode(Node);
			break;
			case OBJ_DATABASES:
				ItemData->NodeType=OBJ_DATABASE;
				Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Databases")->GetChildNodes()->Get(Node->Index)->GetChildNodes()->GetNode("Name");
				ItemData->Caption=Item->Text;
				//ServerTree->HasChildren[Node]=true;
			break;
			case OBJ_LOGIN:
				ItemData->NodeType=OBJ_LOGIN_DATABASE;
				Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Login")->GetChildNodes()->GetNode("Databases")->GetChildNodes()->Get(Node->Index);
				ItemData->Caption=Item->NodeName;
				//ServerTree->HasChildren[Node]=true;
				//ServerTree->InvalidateNode(Node);
			break;
			case OBJ_DATABASE:
				switch (Node->Index)
				{
					case 0:
					ItemData->NodeType=OBJ_USER_TABLES;
					ItemData->Caption="User tables";
					break;
					case 1:
					ItemData->NodeType=OBJ_VIEW_TABLES;
					ItemData->Caption="Views";
					break;
					case 2:
					ItemData->NodeType=OBJ_SYSTEM_TABLES;
					ItemData->Caption="System tables";
					break;
				}
			break;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::ServerTreeExpanding(TBaseVirtualTree *Sender,
	  PVirtualNode Node, bool &Allowed)
{
	ServerNode* NodeData=(ServerNode*)ServerTree->GetNodeData(Node);
	if(NodeData->NodeType!=OBJ_SERVER)
	{
		Lock->Enter();
		ExpandInfo(Node);
		DisplayExpandInfo(Node);
		Lock->Leave();
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::ExpandInfo(TVirtualNode *ExpandingNode)
{
	//ManagerQuery->DisableControls();
	if(!ManagerQuery->UpdateProcessInfo())
	{
		//Disconnect();
		return;
	}
	ServerNode* NodeData=(ServerNode*)ServerTree->GetNodeData(ExpandingNode);
	XmlInfo->Clear();
	XmlInfo->Add("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
	XmlInfo->Add("<Server>");
	switch (NodeData->NodeType)
	{
		case OBJ_LOGINS:
			StatusBar->Panels->Items[4]->Text="Reading login's properties";
			StatusBar->Repaint();
			if(!ManagerQuery->GetLogins(XmlInfo))
			{
				//Add error handle here
			}
		break;
		case OBJ_DATABASES:
			StatusBar->Panels->Items[4]->Text="Checking server's databases";
			StatusBar->Repaint();
			if(!ManagerQuery->HasAccessDatabases(XmlInfo))
			{
				//Add error handle here
			}
		break;
		case OBJ_LOGIN:
			StatusBar->Panels->Items[4]->Text="Reading login's databases";
			StatusBar->Repaint();
			if(!ManagerQuery->GetLoginProperties(XmlInfo,NodeData->Caption,true))
			{
				//Add error handle here
			}
		break;
		case OBJ_DATABASE:
		break;
	}
	XmlInfo->Add("</Server>");
	ServerInfoXml->LoadFromXML(XmlInfo->Text);
	XmlInfo->Clear();
	StatusBar->Panels->Items[4]->Text="";
}
void __fastcall TServerForm::DisplayExpandInfo(TVirtualNode* ExpandingNode)
{
	ServerNode* NodeData=(ServerNode*)ServerTree->GetNodeData(ExpandingNode);
	_di_IXMLNode Item;
	switch (NodeData->NodeType)
	{
		case OBJ_LOGINS:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Logins");
		break;
		case OBJ_DATABASES:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Databases");
		break;
		case OBJ_LOGIN:
			Item=ServerInfoXml->DocumentElement->GetChildNodes()->GetNode("Login")->GetChildNodes()->GetNode("Databases");
		break;
		case OBJ_DATABASE:
			ServerTree->ChildCount[ExpandingNode]=3;
		default: return;
	}
	ServerTree->ChildCount[ExpandingNode]=Item->GetChildNodes()->Count;
	ServerTree->ReinitChildren(ExpandingNode,true);
	ServerTree->InvalidateChildren(ExpandingNode,true);
	//ServerTree->HasChildren[ExpandingNode]=true;
	//Lock->Release();
}
void __fastcall TServerForm::ServerTreeCollapsing(TBaseVirtualTree *Sender,
	  PVirtualNode Node, bool &Allowed)
{
	ServerNode* NodeData=(ServerNode*)ServerTree->GetNodeData(Node);
	switch (NodeData->NodeType)
	{
		case OBJ_LOGINS:
			ServerTree->ChildCount[Node]=0;
		break;
		case OBJ_DATABASES:
			ServerTree->ChildCount[Node]=0;
		break;
		case OBJ_DATABASE:
			ServerTree->ChildCount[Node]=0;
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::InfoTreeMeasureItem(TBaseVirtualTree *Sender,
      TCanvas *TargetCanvas, PVirtualNode Node, int &NodeHeight)
{
	InfoNode* NodeData=(InfoNode*)InfoTree->GetNodeData(Node);
	if(NodeData->Captions->Strings[0]==(WideString)"Status")
	{
        NodeHeight=126;
	}
	else
	{
		NodeHeight=InfoTree->DefaultNodeHeight;
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::RunSqlActionExecute(TObject *Sender)
{
	if(SqlSyntaxMemo->SelText.Length())
	{
		SqlPrepare(SqlSyntaxMemo->SelText);
	}
	else
	{
		SqlPrepare(SqlSyntaxMemo->Text);
	}
	ManagerQuery->Open();
	if(ManagerQuery->LastRunError)
	{
		SqlSyntaxMemo->Lines->Add("/*"+ManagerQuery->LastError+"*/");
	}
	SqlResults->PopulateData();
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::SqlPrepare(WideString SQL)
{
	//WideString BackupCopy=SQL;
	WideString SubString;
	int Break;
	/*int Position=SQL.Pos("//");
	while (Position)
	{
		SubString=SQL.SubString(Position,SQL.Length()-Position);
		Break=SubString.Pos("\r\n");
		if(!Break)
		{
			Break=SQL.Length()-Position;
		}
		SQL.Delete(Position,Break+1);
		Position=(SQL.Pos("//"));
	}
	Position=SQL.Pos("{");
	while(Position)
	{
		SubString= SQL.SubString(Position,SQL.Length()-Position);
		Break=SubString.Pos("}");
		if(!Break)
		{
			Break=SQL.Length()-Position;
		}
		SQL.Delete(Position,Break+1);
		Position=(SQL.Pos("{"));
	}*/
	int Position=SQL.Pos("--");
	while(Position)
	{
		SubString= SQL.SubString(Position,SQL.Length()-Position);
		Break=SubString.Pos("\r\n");
		if(!Break)
		{
			Break=SQL.Length()-Position;
		}
		SQL.Delete(Position,Break+1);
		Position=(SQL.Pos("--"));
	}
	Position=SQL.Pos("/*");
	while(Position)
	{
		SubString= SQL.SubString(Position,SQL.Length()-Position);
		Break=SubString.Pos("*/");
		if(!Break)
		{
			Break=SQL.Length()-Position;
		}
		else
		{
			Break+=1;
		}
		SQL.Delete(Position,Break+1);
		Position=(SQL.Pos("/*"));
	}
	ManagerQuery->SQL->Text=SQL;
}
//---------------------------------------------------------------------------

void __fastcall TServerForm::ClearLogActionExecute(TObject *Sender)
{
	SynMemoLog->ClearAll();
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::LogToFileActionExecute(TObject *Sender)
{
	if(LogToFileAction->Checked)
	{
		LogToFileAction->Checked=false;
		ManagerQuery->SqlLogFileName="";
	}
	else
	{
		LogToFileAction->Checked=true;
		ManagerQuery->SqlLogFileName=LogFile->Text;
		if(!ManagerQuery->SqlLogFileName.Length())
		{
			LogToFileAction->Checked=false;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::ViewSQLActionExecute(TObject *Sender)
{
	ViewSQLAction->Checked=!ViewSQLAction->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::ManagerQueryWriteLog(WideString LogText)
{
	if(ViewSQLAction->Checked)
	{
		try
		{
			TTntStringList *Temp=new TTntStringList;
			Temp->Text=LogText;
			//LogText.SetLength(LogText.Length()-2);
			for(int i=0;i<Temp->Count;i++)
			{
				SynMemoLog->Lines->Add(Temp->Strings[i]);
			}
			delete Temp;
		}
		catch(Exception &e)
		{
			//
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TServerForm::SqlSyntaxMemoKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if(Key==VK_F5)
	{
		RunSqlAction->Execute();
	}
}
//---------------------------------------------------------------------------

