//---------------------------------------------------------------------------

#ifndef SqlAdminMonitorH
#define SqlAdminMonitorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "ADOManagerQuery.h"
#include <ADODB.hpp>
#include "VirtualTrees.hpp"
#include "TntComCtrls.hpp"
#include "SyncObjs.hpp"
#include "te_controls.hpp"
#include "TntStdCtrls.hpp"
#include "TntDBGrids.hpp"
#include <DBGrids.hpp>
#include <Grids.hpp>
#include "TntActnList.hpp"
#include <ActnList.hpp>
#include <ToolWin.hpp>
#include "JvComponent.hpp"
#include "JvExControls.hpp"
#include "JvExExtCtrls.hpp"
#include "JvGradientHeaderPanel.hpp"
#include "JvRollOut.hpp"
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <ExtCtrls.hpp>
#include <msxmldom.hpp>
#include <XMLDoc.hpp>
#include <xmldom.hpp>
#include <XMLIntf.hpp>
#include <DB.hpp>
#include <Forms.hpp>
#include "SynMemo.hpp"
#include "SynEdit.hpp"
#include <ComCtrls.hpp>
#include "SynEditHighlighter.hpp"
#include "SynHighlighterSQL.hpp"
#include "SynEditMiscClasses.hpp"
#include "SynEditSearch.hpp"
//---------------------------------------------------------------------------
struct ServerNode
{
	WideString Caption;
	int NodeType;
};
struct InfoNode
{
	TTntStringList* Captions;
	int NodeType;
};
class TUpdateThread : public TThread
{
private:
	TForm* FOwner;
	TVirtualNode *ServerNode;
protected:
	void __fastcall Execute();
public:
	__fastcall TUpdateThread(bool CreateSuspended, TForm* Owner);
};
struct TSqlResult
{
	TADODataSet *DataSet;
	TDataSource *DataSource;
	TTntDBGrid *DBGrid;
	TTntTabSheet *TabSheet;
	__fastcall TSqlResult(TADODataSet *SourceDataSet);
	__fastcall ~TSqlResult();
};
class TSqlResults
{
private:
	TList* DataResults;
	TComponent* FOwner;
	TTntPageControl* FParent;
	TADOQuery *FADOQuery;
	void __fastcall Show();
public:
	void __fastcall PopulateData();
	void __fastcall Clear();
	__fastcall TSqlResults(TComponent* Owner, TTntPageControl* Parent,TADOQuery* QuerySource);
	__fastcall ~TSqlResults();
};

class TServerForm : public TForm
{
__published:	// IDE-managed Components
	TADOSqlManagerQuery *ManagerQuery;
	TJvRollOut *RollOut;
	TVirtualStringTree *ServerTree;
	TTntStatusBar *StatusBar;
	TXMLDocument *ServerInfoXml;
	TJvGradientHeaderPanel *ServerHeader;
	TButton *CollapseButton;
	TSplitter *PanelSplitter;
	TTeMDIChild *MDIChild;
	TTntPageControl *TntPageControl1;
	TTntTabSheet *TntTabSheet1;
	TVirtualStringTree *InfoTree;
	TTntTabSheet *TntTabSheet2;
	TTntTabSheet *TntTabSheet3;
	TTntToolBar *TntToolBar1;
	TTntToolButton *SqlRunButton;
	TDataSource *DataSource;
	TTntActionList *ServerActionList;
	TTntAction *RunSqlAction;
	TSplitter *Splitter1;
	TTntToolBar *TntToolBar2;
	TTntAction *ClearLogAction;
	TTntToolButton *ClearLoglButton;
	TTntToolButton *ViewSQLButton;
	TTntAction *ViewSQLAction;
	TTntEdit *LogFile;
	TTntAction *LogToFileAction;
	TTntToolButton *LogToFileButton;
	TTntPageControl *DataPageControl;
	TSynMemo *SynMemoLog;
	TSynMemo *SqlSyntaxMemo;
	TSynSQLSyn *SynSQLSyn;
	void __fastcall ServerTreeGetText(TBaseVirtualTree *Sender, PVirtualNode Node,
		  TColumnIndex Column, TVSTTextType TextType, WideString &CellText);
	void __fastcall ServerTreeGetImageIndex(TBaseVirtualTree *Sender,
          PVirtualNode Node, TVTImageKind Kind, TColumnIndex Column,
          bool &Ghosted, int &ImageIndex);
	void __fastcall ServerTreeFreeNode(TBaseVirtualTree *Sender,
          PVirtualNode Node);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall StatusBarDrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall CollapseButtonClick(TObject *Sender);
	void __fastcall InfoTreeFreeNode(TBaseVirtualTree *Sender, PVirtualNode Node);
	void __fastcall InfoTreeInitNode(TBaseVirtualTree *Sender,
          PVirtualNode ParentNode, PVirtualNode Node,
          TVirtualNodeInitStates &InitialStates);
	void __fastcall InfoTreeGetText(TBaseVirtualTree *Sender, PVirtualNode Node,
          TColumnIndex Column, TVSTTextType TextType, WideString &CellText);
	void __fastcall ServerTreeChange(TBaseVirtualTree *Sender, PVirtualNode Node);
	void __fastcall RollOutCollapse(TObject *Sender);
	void __fastcall RollOutExpand(TObject *Sender);
	void __fastcall UpdateInfo();
	void __fastcall ExpandInfo(TVirtualNode *ExpandingNode);
	void __fastcall DisplayExpandInfo(TVirtualNode* ExpandingNode);	
	void __fastcall DisplayInfo();
	void __fastcall ServerTreeInitNode(TBaseVirtualTree *Sender,
          PVirtualNode ParentNode, PVirtualNode Node,
          TVirtualNodeInitStates &InitialStates);
	void __fastcall ServerTreeExpanding(TBaseVirtualTree *Sender,
          PVirtualNode Node, bool &Allowed);
	void __fastcall ServerTreeCollapsing(TBaseVirtualTree *Sender,
          PVirtualNode Node, bool &Allowed);
	void __fastcall InfoTreeMeasureItem(TBaseVirtualTree *Sender,
          TCanvas *TargetCanvas, PVirtualNode Node, int &NodeHeight);
	void __fastcall RunSqlActionExecute(TObject *Sender);
	void __fastcall SqlPrepare(WideString SQL);
	void __fastcall ClearLogActionExecute(TObject *Sender);
	void __fastcall LogToFileActionExecute(TObject *Sender);
	//void __fastcall ManagerQueryWriteLog(WideString LogText);
	void __fastcall ViewSQLActionExecute(TObject *Sender);
	void __fastcall ManagerQueryWriteLog(WideString LogText);
	void __fastcall SqlSyntaxMemoKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
private:	// User declarations
	/*_di_IXMLNode Server;
	_di_IXMLNode Connections;
	_di_IXMLNode Logins;
	_di_IXMLNode Databases;*/
	TCriticalSection *Lock;
	TTntStringList *XmlInfo;
	void __fastcall ServerTreeIni();
	void __fastcall InfoTreeIni();	
	void __fastcall InfoTreeCheckColumn(int count);
	TSqlResults* SqlResults;
	//TUpdateThread* UpdateThread;
public:		// User declarations
	__fastcall TServerForm(TComponent* Owner);
	void __fastcall Login();
	void __fastcall Disconnect();
};
//---------------------------------------------------------------------------
extern PACKAGE TServerForm *ServerForm;
//---------------------------------------------------------------------------
#endif
